import FIFOF::*;
import FIFO::*;


interface Mixer;
   method Action feed(Sample samp, VoiceId id); // feed in a sample to a specific FIFOF
   method Action stream(); // Outputs muxed data.
endinterface


method vectorFull?(Vector#(FIFOF#(Sample)) vect)

   (reduce .notEmpty vect)

endmethod



module mkMixer(Mixer);

   FIFO output = mkFIFO();


   // make vector of fifos, length = MAX_VOICES 
   fifo_vect Vector#(FIFOF#(Sample)) = mkVector(`MAX_VOICES);

   
   for $i(1 .. `MAX_VOICES)
      begin
         fifo_vect[$i] = mkFIFOF();
      end
        
   rule(vectorFull?(fifo_vect))

      Sample out = (/ (reduce + fofo_vector) `MAX_VOICES)
      output.enq(out);
      
   endrule

  
endmodule

